/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2011 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.ui.dnd;

import org.eclipse.gef.dnd.SimpleObjectTransfer;
import org.fortiss.tooling.kernel.service.IConnectionCompositorService;
import org.fortiss.tooling.kernel.service.IElementCompositorService;

/**
 * A {@link SimpleObjectTransfer} singleton used for DND via
 * {@link IElementCompositorService} and {@link IConnectionCompositorService}.
 * 
 * @author hoelzl
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating RED Hash: E8FE5EC5C36C0A8456AEBC887D735DDF
 */
public class CompositionServiceLocalTransfer extends SimpleObjectTransfer {
	/** Singleton instance. */
	private static final CompositionServiceLocalTransfer INSTANCE = new CompositionServiceLocalTransfer();
	/** Transfer type name. */
	// TODO @review CD: Why does it need such a complex name? Super class
	// already handles timing .
	private static final String TYPE_NAME = "Fortiss kernel composition transfer"
			+ System.currentTimeMillis() + ":" + INSTANCE.hashCode();
	/** Transfer type ID. */
	private static final int TYPEID = registerType(TYPE_NAME);

	/** Returns the singleton instance. */
	public static CompositionServiceLocalTransfer getInstance() {
		return INSTANCE;
	}

	/** {@inheritDoc} */
	@Override
	protected int[] getTypeIds() {
		return new int[] { TYPEID };
	}

	/** {@inheritDoc} */
	@Override
	protected String[] getTypeNames() {
		return new String[] { TYPE_NAME };
	}
}
